%global dridir %{_libdir}/dri
%global vdpaudir %{_libdir}/vdpau
%global drilinks %{_tmppath}/dri-links-state
%global vdpaulinks %{_tmppath}/vdpau-links-state
%define module mesa
%define debug_package %{nil}
%define _prefix %(%{SOURCE1} --prefix %{module}_uni)
%define state %{expand:%{%{1}links}}

%define create_links() \
sysdir="%{expand:%%{%{1}dir}}" \
amddir="%{_libdir}/%{1}" \
mkdir -p $sysdir \
for f in $amddir/*.so*; do \
  l="$(readlink -e $f)" \
  if [ "${l%/*}" != "$sysdir" ]; then \
    ln -sb $f $sysdir \
  fi \
done \
touch %{state}

%define remove_links() \
sysdir="%{expand:%%{%{1}dir}}" \
amddir="%{_libdir}/%{1}" \
if [ -d "$sysdir" ]; then \
  for f in $(find $sysdir -type l -a -not -name \\*~); do \
    l=$(readlink $f) \
    if [ "${l%/*}" = "$amddir" ]; then \
      rm -f $f \
      [ -f $f~ ] && mv -f $f~ $f \
    fi \
  done \
fi \
rm -f %{state}

%define create_links_dri \
%create_links dri \
# Support I+A hybrid graphics \
if [ -f %{dridir}/i965_dri.so ] && [ "%{dridir}" != "%{_libdir}/dri" ]; then \
  ln -s %{dridir}/i965_dri.so %{_libdir}/dri \
fi

%define remove_links_dri \
# Support I+A hybrid graphics \
rm -f %{_libdir}/dri/i965_dri.so \
%remove_links dri

Summary: Mesa graphics libraries
Name: mesa-amdgpu
Version: 20.0.5
Release: 1089974.el8
Epoch: 1
License: MIT
Group: System Environment/Libraries
URL: http://www.mesa3d.org
Source1: rbh.sh
Source2: rbh.conf
Source100: mesa.rbh
Source101: mesa-20.0.5.tar.gz

Patch0: 0001-Lower-libglvnd-requirement.patch

BuildRequires: gcc-c++
BuildRequires: pkgconfig
BuildRequires: autoconf
BuildRequires: automake
BuildRequires: libtool
BuildRequires: libdrm-devel
BuildRequires: libdrm-amdgpu-devel = 1:2.4.100-1089974.el8
%if 0%{?suse_version}
BuildRequires: glibc-devel
BuildRequires: libgcc_s1
BuildRequires: libstdc++-devel
BuildRequires: libexpat-devel
BuildRequires: libXxf86vm-devel
BuildRequires: libselinux-devel
BuildRequires: libXext-devel
BuildRequires: libXfixes-devel
BuildRequires: libXdamage-devel
BuildRequires: libxshmfence-devel
BuildRequires: libelf-devel
BuildRequires: kernel-source
BuildRequires: xorg-x11-server-sdk
BuildRequires: libvdpau-devel
BuildRequires: libva-devel
BuildRequires: zlib-devel
BuildRequires: libxcb-devel
BuildRequires: libX11-devel
BuildRequires: libXrandr-devel >= 1.3
BuildRequires: ninja
%if %{suse_version} >= 1500
BuildRequires: python3-Mako
%endif
%else
BuildRequires: glibc-devel%{?_isa}
BuildRequires: libgcc%{?_isa}
BuildRequires: libstdc++-devel%{?_isa}
BuildRequires: libXxf86vm-devel%{?_isa}
BuildRequires: libselinux-devel%{?_isa}
BuildRequires: libXext-devel%{?_isa}
BuildRequires: libXfixes-devel%{?_isa}
BuildRequires: libXdamage-devel%{?_isa}
BuildRequires: libxshmfence-devel%{?_isa}
BuildRequires: elfutils-libelf-devel%{?_isa}
BuildRequires: libvdpau-devel%{?_isa}
BuildRequires: libva-devel
BuildRequires: zlib-devel%{?_isa}
BuildRequires: libxcb-devel%{?_isa}
BuildRequires: libX11-devel%{?_isa}
BuildRequires: libXrandr-devel%{?_isa} >= 1.3
BuildRequires: expat-devel
BuildRequires: kernel-headers
BuildRequires: xorg-x11-server-devel
%endif
BuildRequires: xorg-x11-proto-devel
BuildRequires: makedepend
BuildRequires: libXi-devel
BuildRequires: libXmu-devel
BuildRequires: elfutils
BuildRequires: meson
BuildRequires: python3-mako
BuildRequires: /usr/bin/python3
%if 0%{?rhel} > 7 || 0%{?fedora}
BuildRequires: python3-libxml2
%endif
BuildRequires: gettext
BuildRequires: llvm-amdgpu-devel = 1:10.0-1089974.el8
BuildRequires: libudev-devel
BuildRequires: bison flex
%if 0%{?fedora}
BuildRequires: wayland-protocols-amdgpu-devel
BuildRequires: wayland-amdgpu-devel
%endif
%if 0%{?rhel} > 7 || 0%{?suse_version} >= 1500
BuildRequires: wayland-protocols-devel >= 1.8
BuildRequires: wayland-devel >= 1.11
%endif
%if 0%{?rhel} > 7 || 0%{?suse_version} >= 1500 || 0%{?fedora}
BuildRequires: pkgconfig(wayland-client) >= 1.0
BuildRequires: pkgconfig(wayland-server) >= 1.0
%endif
%if 0%{?fedora}
BuildRequires: libomxil-bellagio-devel
BuildRequires: libglvnd-devel
%endif
%if 0%{?rhel} && 0%{?rhel} < 8
BuildRequires: devtoolset-6
%endif

%description
Mesa

%package libGL
Summary: Mesa libGL runtime libraries and DRI drivers
Group: System Environment/Libraries
Provides: libGL
Requires: amdgpu-core

%description libGL
Mesa libGL runtime library.

%package libEGL
Summary: Mesa libEGL runtime libraries
Group: System Environment/Libraries
Requires: amdgpu-core

%description libEGL
Mesa libEGL runtime libraries

%if %{?fedora:0}%{!?fedora:1}
%package libGLES
Summary: Mesa libGLES runtime libraries
Group: System Environment/Libraries
Requires: amdgpu-core

%description libGLES
Mesa GLES runtime libraries
%endif

%package filesystem
Summary: Mesa driver filesystem
Group: User Interface/X Hardware Support
Requires: amdgpu-core

%description filesystem
Mesa driver filesystem

%package dri-drivers
Summary: Mesa-based DRI drivers
Group: User Interface/X Hardware Support
Requires: %{name}-filesystem%{?_isa}

%description dri-drivers
Mesa-based DRI drivers.

%package vdpau-drivers
Summary: Mesa-based DRI drivers
Group: User Interface/X Hardware Support
Requires: %{name}-filesystem%{?_isa}

%description vdpau-drivers
Mesa-based VDPAU drivers.

%package libGL-devel
Summary: Mesa libGL development package
Group: Development/Libraries
Requires: %{name}-libGL = %{epoch}:%{version}-%{release}
%if %{?suse_version:0}%{!?suse_version:1}
Requires: gl-manpages
%endif

%description libGL-devel
Mesa libGL development package

%package libEGL-devel
Summary: Mesa libEGL development package
Group: Development/Libraries
Requires: %{name}-libEGL = %{epoch}:%{version}-%{release}

%description libEGL-devel
Mesa libEGL development package

%package libGLES-devel
Summary: Mesa libGLES development package
Group: Development/Libraries
%if %{?fedora:0}%{!?fedora:1}
Requires: %{name}-libGLES = %{epoch}:%{version}-%{release}
%endif

%description libGLES-devel
Mesa libGLES development package

%package libOSMesa
Summary: Mesa offscreen rendering libraries
Group: System Environment/Libraries
Provides: libOSMesa
Requires: amdgpu-core

%description libOSMesa
Mesa offscreen rendering libraries

%package libOSMesa-devel
Summary: Mesa offscreen rendering development package
Group: Development/Libraries
Requires: %{name}-libOSMesa = %{epoch}:%{version}-%{release}

%description libOSMesa-devel
Mesa offscreen rendering development package

%package libgbm
Summary: Mesa gbm library
Group: System Environment/Libraries
Provides: libgbm
Requires: amdgpu-core

%description libgbm
Mesa gbm runtime library.

%package libgbm-devel
Summary: Mesa libgbm development package
Group: Development/Libraries
Requires: %{name}-libgbm%{?_isa} = %{epoch}:%{version}-%{release}

%description libgbm-devel
Mesa libgbm development package

%package libxatracker
Summary: Mesa XA state tracker
Group: System Environment/Libraries
Provides: libxatracker
Requires: amdgpu-core

%description libxatracker
Mesa XA state tracker

%package libxatracker-devel
Summary: Mesa XA state tracker development package
Group: Development/Libraries
Requires: %{name}-libxatracker%{?_isa} = %{epoch}:%{version}-%{release}

%description libxatracker-devel
Mesa XA state tracker development package

%package libglapi
Summary: Mesa shared glapi
Group: System Environment/Libraries
Requires: amdgpu-core

%description libglapi
Mesa shared glapi

%if 0%{?fedora}
%package omx-drivers
Summary: OpenMAX support for Mesa
Group: System Environment/Libraries
Requires: amdgpu-core

%description omx-drivers
OpenMAX support for Mesa
%endif

%prep
tar -C %{_sourcedir} -zxvf %{SOURCE101}

%{SOURCE1} --prep %{module}_uni
%setup -T -D -n %{module}
pushd %{_sourcedir}/%{module}
%if 0%{?fedora}
%patch0 -p1
%endif
%if 0%{?rhel} == 7
sed -i "s|include <linux/kcmp.h>|define KCMP_FILE 0|" src/util/os_file.c
%endif
sed -i "/subdir('compiler')/d" src/amd/meson.build
popd

%build
%{SOURCE1} --build %{module}_uni

%install
%{SOURCE1} --install %{module}_uni

%clean
rm -rf %{buildroot} %{_builddir}/mesa
rm -rf %{_sourcedir}/mesa


%pre dri-drivers
%remove_links_dri

%post dri-drivers
%create_links_dri

%preun dri-drivers
%remove_links_dri

%postun dri-drivers
if [ $1 -eq 1 ]; then
  %create_links_dri
fi

%pre vdpau-drivers
%remove_links vdpau

%post vdpau-drivers
%create_links vdpau

%preun vdpau-drivers
%remove_links vdpau

%postun vdpau-drivers
if [ $1 -eq 1 ]; then
  %create_links vdpau
fi

%post libGL -p /sbin/ldconfig
%postun libGL -p /sbin/ldconfig
%post libOSMesa -p /sbin/ldconfig
%postun libOSMesa -p /sbin/ldconfig
%post libEGL -p /sbin/ldconfig
%postun libEGL -p /sbin/ldconfig
%if %{?fedora:0}%{!?fedora:1}
%post libGLES -p /sbin/ldconfig
%postun libGLES -p /sbin/ldconfig
%endif
%post libglapi -p /sbin/ldconfig
%postun libglapi -p /sbin/ldconfig
%post libgbm -p /sbin/ldconfig
%postun libgbm -p /sbin/ldconfig
%post libxatracker -p /sbin/ldconfig
%postun libxatracker -p /sbin/ldconfig

%files libGL
%if 0%{?fedora}
%{_libdir}/libGLX_mesa.so.0*
%{_libdir}/libGLX_indirect.so.0*
%else
%{_libdir}/libGL.so.1
%{_libdir}/libGL.so.1.*
%endif

%files libEGL
%if 0%{?fedora}
%{_datadir}/glvnd/egl_vendor.d/50_mesa.json
%{_libdir}/libEGL_mesa.so.0*
%else
%{_libdir}/libEGL.so.1
%{_libdir}/libEGL.so.1.*
%endif

%if %{?fedora:0}%{!?fedora:1}
%files libGLES
%{_libdir}/libGLESv2.so.2
%{_libdir}/libGLESv2.so.2.*
%endif

%files filesystem
%dir %{_libdir}/dri
%dir %{_libdir}/vdpau

%files libglapi
%{_libdir}/libglapi.so.0
%{_libdir}/libglapi.so.0.*

%files dri-drivers
%dir %{_datadir}/drirc.d
%config(noreplace) %{_datadir}/drirc.d/*.conf
%config(noreplace) %{_prefix}/%{_sysconfdir}/drirc
%{_libdir}/dri/*.so

%files vdpau-drivers
%{_libdir}/vdpau/*.so.1*

%files libGL-devel
%{_includedir}/GL/*.h
%dir %{_includedir}/GL/internal
%{_includedir}/GL/internal/*.h
%{_libdir}/pkgconfig/dri.pc
%if %{?fedora:0}%{!?fedora:1}
%{_libdir}/pkgconfig/gl.pc
%{_libdir}/libGL.so
%endif
%{_libdir}/libglapi.so

%files libEGL-devel
%dir %{_includedir}/EGL
%{_includedir}/EGL/*.h
%if %{?fedora:0}%{!?fedora:1}
%dir %{_includedir}/KHR
%{_includedir}/KHR/khrplatform.h
%{_libdir}/pkgconfig/egl.pc
%{_libdir}/libEGL.so
%endif

%files libGLES-devel
%if %{?fedora:0}%{!?fedora:1}
%dir %{_includedir}/GLES
%{_includedir}/GLES/*.h
%dir %{_includedir}/GLES2
%{_includedir}/GLES2/*.h
%dir %{_includedir}/GLES3
%{_includedir}/GLES3/*.h
%{_libdir}/pkgconfig/glesv2.pc
%{_libdir}/libGLESv2.so
%{_libdir}/libGLESv1_CM.so
%{_libdir}/libGLESv1_CM.so.1*
%{_libdir}/pkgconfig/glesv1_cm.pc
%endif

%files libgbm
%{_libdir}/libgbm.so.1
%{_libdir}/libgbm.so.1.*

%files libgbm-devel
%{_libdir}/libgbm.so
%{_includedir}/gbm.h
%{_libdir}/pkgconfig/gbm.pc

%files libOSMesa
%{_libdir}/libOSMesa.so.8*

%files libOSMesa-devel
%dir %{_includedir}/GL
%{_includedir}/GL/osmesa.h
%{_libdir}/libOSMesa.so
%{_libdir}/pkgconfig/osmesa.pc

%files libxatracker
%{_libdir}/libxatracker.so.2
%{_libdir}/libxatracker.so.2.*

%files libxatracker-devel
%{_libdir}/libxatracker.so
%{_includedir}/xa_tracker.h
%{_includedir}/xa_composite.h
%{_includedir}/xa_context.h
%{_libdir}/pkgconfig/xatracker.pc

%if 0%{?fedora}
%files omx-drivers
%dir %{_libdir}/bellagio
%{_libdir}/bellagio/libomx_mesa.so
%endif

%if 0%{?suse_version}
%triggerprein dri-drivers -- Mesa
%else
%triggerprein dri-drivers -- mesa-dri-drivers
%endif
if [ $1 -eq 1 ]; then
  %remove_links_dri
fi

%if 0%{?suse_version}
%triggerpin dri-drivers -- Mesa
%else
%triggerin dri-drivers -- mesa-dri-drivers
%endif
if [ ! -f %{drilinks} ]; then
  %create_links_dri
fi

%if 0%{?suse_version}
%triggerun dri-drivers -- Mesa
%else
%triggerun dri-drivers -- mesa-dri-drivers
%endif
if [ $1 -eq 1 ]; then
  %remove_links_dri
fi

%if 0%{?suse_version}
%triggerpostun dri-drivers -- Mesa
%else
%triggerpostun dri-drivers -- mesa-dri-drivers
%endif
%create_links_dri

%if 0%{?suse_version}
%triggerprein vdpau-drivers -- Mesa
%else
%triggerprein vdpau-drivers -- mesa-vdpau-drivers
%endif
if [ $1 -eq 1 ]; then
  %remove_links vdpau
fi

%if 0%{?suse_version}
%triggerpin vdpau-drivers -- Mesa
%else
%triggerin vdpau-drivers -- mesa-vdpau-drivers
%endif
if [ ! -f %{vdpaulinks} ]; then
  %create_links vdpau
fi

%if 0%{?suse_version}
%triggerun vdpau-drivers -- Mesa
%else
%triggerun vdpau-drivers -- mesa-vdpau-drivers
%endif
if [ $1 -eq 1 ]; then
  %remove_links vdpau
fi

%if 0%{?suse_version}
%triggerpostun vdpau-drivers -- Mesa
%else
%triggerpostun vdpau-drivers -- mesa-vdpau-drivers
%endif
%create_links vdpau


%changelog
* Tue Jun 09 2020 AMD automated build system <gpudriverdevsupport@amd.com> 20.0.5-1089974.el8
- mesa 
- gerritgit/releases/amd-20.20
- 1aae81d4105fd4bc4d451bc01e0ba54f73b64076
- build ID: 1089974

